import prog.io.*;
import prog.utili.Cerchio;
import prog.utili.Figura;
import prog.utili.Rettangolo;
import prog.utili.Quadrato;


class FiguraAreaMaxII{

  public static void main(String[] args) {
      //predisposizione dei canali di comunicazione
      ConsoleOutputManager out = new ConsoleOutputManager();
      ConsoleInputManager in = new ConsoleInputManager();

      Figura r, rAreaMax = null;
      boolean continuare = true;
      double x, y;
      char scelta;

      do{
	  //scelta figura
	  out.println("Scelta della figura:");
	  out.println();
	  out.println(" r Inserisce un rettangolo");
	  out.println(" q Inserisce un quadrato");
	  out.println(" c Inserisce un cerchio");
	  out.println(" f Fine inserimento");
	  out.println();
	  scelta = in.readChar("   Scelta? ");
   
	  //lettura dati figura
	  boolean inseritaFigura = false;
	  switch (scelta) {
	  case 'r':
	  out.println("Inserisci i dati del rettangolo:");
	  x = in.readDouble(" - base?  ");
	  y = in.readDouble(" - altezza? ");

	  //controllo dati e costruzione dell'oggetto
	  if (x < 0 || y < 0)
	      out.println("I dati inseriti non sono corretti");
	  else {
	      r = x == y ? new Quadrato(x) : new Rettangolo(x, y);
	      inseritaFigura = true;
	      }
	  break;
	  case 'q':
	      out.println("Inserisci i dati del quadrato:");
	      x = in.readDouble(" - lato?  ");

	  //controllo dati e costruzione dell'oggetto
	      if (x < 0)
		  out.println("Il dato inserito non e' corretto");
	      else {
	      r = new Quadrato(x);
	      inseritaFigura = true;
	  	      }
	  break;
	  case 'c':
	      out.println("Inserisci i dati del cerchio:");
	      x = in.readDouble(" - raggio?  ");
	  
	  //controllo dati e costruzione dell'oggetto
	      if (x < 0)
		  out.println("Il dato inserito non e' corretto");
	      else {
		  r = new Cerchio(x);
		  inseritaFigura = true;
	      }
	  break;
	  case 'f':
	      continuare = false;
	  break;
	  default:
	      out.println("   Scelta non valida\n\n");
	      break;
	  }
	  if(inseritaFigura) {
	      out.println("  " + r.toString());
	      out.println(" area =  " + r.getArea() + 
			  ", perimetro = " + r.getPerimetro());
	  }
	      //confronto
	      if (rAreaMax == null || r.haAreaMaggiore(rAreaMax))
		  rAreaMax = r;
	  }
      out.println();
  } while (continuare);

      //comunicazione risultato
      if (rAreaMax == null)
	  out.println("Non e' stato inserito alcuna figura");
      else{
	  out.println("La figura di area maggiore e' un ");
	  if (rAreaMax instanceof Quadrato)
	      out.println("quadrato: ");
	  else if  (rAreaMax instanceof Cerchio)
	      out.println("cerchio: ");
	  else  out.println("rettangolo: ");
	  out.println("  " + rAreaMax.toString());
	  out.println("  area = " + rAreaMax.getArea() +
		      ", perimetro = " + rAreaMax.getPerimetro());
      }
  }
}
